/* http://www.nw-fva.de
   Version 05-01-2018

   (c) 2007-18 Jan Hansen, Northwest German Forest Research Station, 
       Grätzelstr.2, 37079 Göttingen, Germany
       E-Mail: Jan.Hansen@nw-fva.de
 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT  WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 */
package de.nwfva.silviculture.gui;

/**
 *
 * @author jhansen
 */
public class TeLabelClassPair implements Comparable<TeLabelClassPair> {

    private final String label;
    private final Class teClass;
    private final int group;

    public TeLabelClassPair(String label, Class c, int group) {
        this.label = label;
        this.teClass = c;
        this.group = group;
    }

    public String getLabel() {
        return label;
    }

    public Class getTeClass() {
        return teClass;
    }

    @Override
    public String toString() {
        return label;
    }

    @Override
    public int compareTo(TeLabelClassPair o) {
        String otherCompString = o.getGroup() + "_" + o.getLabel();
        String thisCompString = group + "_" + label;
        return thisCompString.compareTo(otherCompString);
    }

    /**
     * @return the group
     */
    public int getGroup() {
        return group;
    }
}
