/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.nwfva.silviculture.wet;

import de.nwfva.silviculture.base.RBHolder;
import de.nwfva.silviculture.base.TeChain;
import de.nwfva.silviculture.base.TePhase;
import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.util.Locale;
import java.util.ResourceBundle;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import treegross.base.SpeciesDefMap;
import treegross.base.Stand;
import treegross.tools.XmlTool;

/**
 *
 * @author nagel
 */
public class Wetlist {

    public Wet wets[] = null;
    ResourceBundle rb = null;
    
    public Wetlist(){
       loadFromJar(); 
    }

    private void loadFromJar() {
        URL xmlPath = getClass().getResource("/de/nwfva/silviculture/wet/wet.xml");
        this.loadWetlist(xmlPath);
    }


    public void loadWetlist(URL nameXML) {
        try {
            URL url = nameXML;
            URLConnection urlcon = url.openConnection();
            Document d = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(urlcon.getInputStream());
            Element Kaskaden = d.getDocumentElement();
            NodeList kaskaden = Kaskaden.getElementsByTagName("wet");
            Node kaskade;
            wets = new Wet[kaskaden.getLength()];
            for (int ikas = 0; ikas < kaskaden.getLength(); ikas++) {
                kaskade = kaskaden.item(ikas);
                int pclass = 0;
                wets[ikas] = new Wet();
                wets[ikas].name = XmlTool.getChildText(kaskade, "Name");
                wets[ikas].code = Integer.parseInt(XmlTool.getChildText(kaskade, "Code"));
                wets[ikas].art1 = XmlTool.getChildText(kaskade, "Art1");
                wets[ikas].anteil1 = Integer.parseInt(XmlTool.getChildText(kaskade, "Anteil1"));
                wets[ikas].art2 = XmlTool.getChildText(kaskade, "Art2");
                wets[ikas].anteil2 = Integer.parseInt(XmlTool.getChildText(kaskade, "Anteil2"));
                wets[ikas].artS = XmlTool.getChildText(kaskade, "ArtS");
                wets[ikas].anteilS = Integer.parseInt(XmlTool.getChildText(kaskade, "AnteilS"));
                wets[ikas].mform = XmlTool.getChildText(kaskade, "MForm");
            }
        } catch (Exception e) {
            
            e.printStackTrace();
        }
    }
    
    public Wet[] getWetlist(){
        return wets;
    } 
    
    private String fileStringToUrl(String fname){
        int m = fname.toUpperCase().indexOf("FILE");
        int m2 = fname.toUpperCase().indexOf("HTTP");
        if (m < 0 && m2 < 0) {
            fname = "file:" + System.getProperty("file.separator")
                    + System.getProperty("file.separator") + System.getProperty("file.separator") + fname;
        }
        return fname;
    }
    
    public int findWet(Stand st){
        int erg = 0;
        int a1 = -987;
        double m1 = 0.0;
        int a2 = -9870;
        double m2 = 0.0;
        for (int i=0; i < st.nspecies;i++){
            if (st.sp[i].percCSA > m1){
                a1 = st.sp[i].code;
                m1 = st.sp[i].percCSA;
            }
        }
        for (int i=0; i < st.nspecies;i++){
            if (st.sp[i].percCSA > m2 && a1 != st.sp[i].code){
                a2 = st.sp[i].code;
                m2 = st.sp[i].percCSA;
            }
        }
        // Jetzt den WET suchen
        int merk = -9;
        double score = 0;
        double scoremax =0;
        boolean a11ok = false; 
        boolean a21ok = false; 
        boolean a12ok = false; 
        boolean a22ok = false; 
        for (int i=0; i < wets.length;i++){
            score =0.0;       
            a11ok = false; 
            a21ok = false; 
            a12ok = false; 
            a22ok = false; 
            if (wets[i].art1.indexOf(Integer.toString(a1)) >= 0){
                score = (100-Math.abs(wets[i].anteil1-m1));
                a11ok = true;
            }
            if (wets[i].art2.indexOf(Integer.toString(a1)) >= 0){
                score = (100-Math.abs(wets[i].anteil2-m1));
                a12ok = true;
            }
            if (wets[i].art1.indexOf(Integer.toString(a2)) >= 0){
                score = score+ 100-Math.abs(wets[i].anteil1-m2);
                a21ok = true;
            }
            if (wets[i].art2.indexOf(Integer.toString(a2)) >= 0){
                score = score+ 100-Math.abs(wets[i].anteil2-m2);
                a22ok = true;
            }
            if (a11ok && a22ok ) score =score+25000;
            if (a12ok && a21ok ) score =score+20000;
            if (a11ok && !a21ok && !a22ok) score = score +10000;
            if (a12ok && !a21ok && !a22ok) score =score+6000;
            if (a21ok && !a11ok && !a12ok) score =score+4000;
            if (a22ok && !a11ok && !a12ok) score =score+2000;

            if (scoremax < score){
                merk = i;
                scoremax = score;
            } 
        }
        if (merk > -9) erg = wets[merk].code;
        return erg;
    }
    
    public int getWetIndex(int codex){
        int erg = 0;
        for (int i=0; i < wets.length;i++){
            if (wets[i].code == codex) erg=i;
        }
        return erg;
    }
    
    public TeChain loadWetChain(int code, SpeciesDefMap sdm){
        TeChain chain= null;
        Locale currentLocale = new Locale("de", "");
        rb = ResourceBundle.getBundle("de.nwfva.silviculture.gui.TeGuiText", currentLocale);
        RBHolder.setResourceBundle(rb);

        String phaseTxt = "phase";
        String chainTxt = "chain";
        if (RBHolder.getResourceBundle() != null) {
            try {
                phaseTxt = RBHolder.getResourceBundle().getString("te_phase_txt");
                chainTxt = RBHolder.getResourceBundle().getString("te_chain_txt");
            } catch (Exception ignore) {
            }
        }
        chain = new TeChain(sdm);
        chain.addTreatmentElement(new TePhase(phaseTxt + "1"));
        chain.setName(chainTxt + "1");
        String txt = "/de/nwfva/silviculture/wet/wet"+code+".xml";
        
        URL xmlPath = getClass().getResource(txt);
        chain.parseUrl(xmlPath);

        return chain;
    }


    
}
