/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forestsimulator.standsimulation;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.logging.Level;
import java.util.logging.Logger;
import treegross.base.DataExchangeFormat;
import treegross.base.Stand;
import treegross.tools.XmlTool;


/**
 *
 * @author nagel
 */
public class TgReadNFPcsv {
    
    private final static Logger LOGGER = Logger.getLogger(DataExchangeFormat.class.getName());

    
    public Stand readNFPCSV( Stand st, String fname){
                InputStream is = null;
        try {
           return readTreegrossStandFromStream(st, fname);
        } catch (Exception e) {
            LOGGER.log(Level.SEVERE, "readNFPCSV", e);
        } finally {
            if (is != null) {
                try {
                    is.close();
                } catch (IOException ex) {
                    LOGGER.log(Level.SEVERE, "readNFPCSV", ex);
                }
            }
        }
        return null;
    }
    
        public Stand readTreegrossStandFromStream(Stand stl, String fn) {
        Stand st;
        String s;
        

        if (stl != null) {
            st = stl;
        } else {
            st = new Stand();
        }
        try {
            BufferedReader in
                    = new BufferedReader(
                            new InputStreamReader(
                                    new FileInputStream(fn)));

            in.readLine();
            st.addName("NFP Plot");
            double xm = st.center.x;
            double ym = st.center.y;

            while (true) {
                s = in.readLine();
                String[] sr = s.split(";"); 
                System.out.println("Read NFP CSV: "+s);                
                if (s == null) {
                    break;
                }
                double xp= -9;
                double yp= -9;
                String namex = sr[0]+sr[1];
                String nrx   = sr[2];
                double gon = Double.parseDouble(sr[3]);
                double ent = Double.parseDouble(sr[4])/100;
                int artx = Integer.parseInt(sr[6]);
                int altx = Integer.parseInt(sr[7]);
                double d1 = Double.parseDouble(sr[8])/10;
                double d2 = Double.parseDouble(sr[9])/10;
                if (d2 > 0 ) d1 = (d1+d2)/2;
                double hx = Double.parseDouble(sr[11])/10;
                double kax = Double.parseDouble(sr[12])/10;
                xp=st.center.x+Math.sin(Math.PI*gon/200.0)*ent;
                yp=st.center.y+Math.cos(Math.PI*gon/200.0)*ent;

                    st.addXMLTree(artx,
                            nrx,
                            altx,
                            -1, 0,
                            d1,
                            hx,
                            kax,
                            -9,
                            -9,
                            1.0,
                            xp,
                            yp,
                            0,
                            false,
                            false,
                            false,
                            0,
                            0,
                            ""
                    );

                
                
                
                
            }
            in.close();

            /*            for (int i = 0; i < trees.getLength(); i++) {
                n = trees.item(i);
                int out;// = -1 ;
                //if (Boolean.parseBoolean(baum.getChild("Entnommen").getText())==false) // wenn so dann muss hier flase nuss hier mit true abgeglichen werden
                out = Integer.parseInt(XmlTool.getChildText(n, "AusscheideJahr"));
                int outtype = 0;
                String ausGrund = XmlTool.getChildText(n, "AusscheideGrund");
                if (ausGrund.contains("Mort")) {
                    outtype = 1;
                } else if (ausGrund.contains("Durch")) {
                    outtype = 2;
                } else if (ausGrund.contains("Ernte")) {
                    outtype = 3;
                }
               }

            }
*/
        } catch ( Exception ex) {
           LOGGER.log(Level.SEVERE, "treegross", ex);
        }
        return st;
    }
        
    
    
}
