/* http://www.nw-fva.de
   Version 07-11-2008

   (c) 2002 Juergen Nagel, Northwest German Forest Research Station, 
       Grtzelstr.2, 37079 Gttingen, Germany
       E-Mail: Juergen.Nagel@nw-fva.de
 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT  WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 */
package forestsimulator.standsimulation;

//import treegross.treatment.*;
import de.nwfva.silviculture.base.TeChain;
import de.nwfva.silviculture.gui.TeSimpleTreePanel;
import de.nwfva.silviculture.wet.Wetlist;
import java.text.*;
import java.util.*;
import treegross.base.*;
import treegross.treatment.*;

/**
 *
 * @author  nagel
 */
public class TgTreatmentMan4 extends javax.swing.JPanel {
    Stand st = null;
    javax.swing.table.DefaultTableModel data= null;
    Object[] rowData={" "," "," "," "," "," "};
    NumberFormat f=NumberFormat.getInstance();
    ResourceBundle messages;
    Locale currentLocale;
    TgYieldTable  yt  = null;
    Treatment2 treat = new Treatment2();
    //TeSimpleTreePanel stpanel =null;
    TeSimpleTreePanel stpanel =null;
    TeChain teChain = null;
    String currentFile = null;
    Wetlist wetlist = null;
    
    /** Creates new form TgTreatmentMan3 */
    public TgTreatmentMan4(Stand stparent,  TgJFrame frameparent, String preferredLanguage) {
        initComponents();
        st = stparent;       
        Locale currentLocale;
        yt = frameparent.yt;
        currentFile = frameparent.currentFile;
        currentLocale = new Locale(preferredLanguage, "");
        messages = ResourceBundle.getBundle("forestsimulator.standsimulation.TgJFrame",currentLocale);
        jLabel10.setText(messages.getString("simulationtime"));
        jLabel11.setText(messages.getString("years"));

        jCheckBox1.setText(messages.getString("randomEffects"));
        jCheckBox2.setText(messages.getString("ingrowthModell"));
        jCheckBox5.setText(messages.getString("riskModel"));
        jButton2.setText(messages.getString("startSimulation"));
        jTextField1.setText(new Integer(st.bt).toString());
        stpanel = new TeSimpleTreePanel(currentLocale,frameparent.SDM);
        stpanel.setStand(st);        
        stpanel.setExecuteButtonVisible(false);
        if (st.ingrowthActive) jCheckBox2.setSelected(true);
        else  jCheckBox2.setSelected(false);
        if (st.riskActive) jCheckBox5.setSelected(true);
        else  jCheckBox5.setSelected(false);
        add(stpanel);
        wetlist = new Wetlist();
        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        jPanel1.setBackground(new java.awt.Color(204, 204, 204));
        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jLabel10.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel10.setText("Simulation: Dauer");
        jPanel1.add(jLabel10);

        jTextField5.setText("5");
        jTextField5.setPreferredSize(new java.awt.Dimension(22, 20));
        jTextField5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField5ActionPerformed(evt);
            }
        });
        jPanel1.add(jTextField5);

        jLabel11.setText("Jahre");
        jPanel1.add(jLabel11);

        jPanel2.setLayout(new java.awt.GridLayout(2, 2));

        jCheckBox1.setSelected(true);
        jCheckBox1.setText("Zufallseffekte");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jPanel2.add(jCheckBox1);

        jCheckBox2.setSelected(true);
        jCheckBox2.setText("Einwuchsmodell");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jPanel2.add(jCheckBox2);

        jCheckBox5.setSelected(true);
        jCheckBox5.setText("Risikomodell");
        jPanel2.add(jCheckBox5);

        jCheckBox3.setText("Save each step");
        jPanel2.add(jCheckBox3);

        jPanel1.add(jPanel2);

        jPanel3.setLayout(new java.awt.GridLayout(2, 2));

        jLabel1.setText("BT:");
        jPanel3.add(jLabel1);

        jLabel3.setText("jLabel3");
        jPanel3.add(jLabel3);

        jLabel2.setText("WET:");
        jPanel3.add(jLabel2);

        jTextField1.setText("-99");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jPanel3.add(jTextField1);

        jPanel1.add(jPanel3);

        jButton2.setText("Simulation starten");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);

        jButton1.setText("?");
        jButton1.setToolTipText("help");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        add(jPanel1, java.awt.BorderLayout.NORTH);
    }// </editor-fold>//GEN-END:initComponents

private void jTextField5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField5ActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_jTextField5ActionPerformed

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    // Execute treatment chain, mortality and growth
    if (jCheckBox1.isSelected()) {
        st.random.setRandomType(11);
    } else {
        st.random.setRandomType(10);
    }
    boolean autosave = false;
    if (jCheckBox3.isSelected()) autosave = true;
    st.ingrowthActive = jCheckBox2.isSelected();
    st.riskActive = jCheckBox5.isSelected();
    st.distanceDependent = true;
    System.out.println("Bestandestyp. st.temp_Integer "+st.temp_Integer);
    int simTime = Integer.parseInt(jTextField5.getText());
    int nSimSteps = (int) Math.ceil(Double.parseDouble(jTextField5.getText()) / st.timeStep);
    if (simTime == 0) {
//        System.out.println("St.status+ harvesttype:"+st.status+"  "+st.trule.typeOfHarvest+" "+st.trule.lastTreatment);
        st.descspecies();
        teChain = stpanel.getChain();
        teChain.execute(st);
        st.descspecies();
        st.notifyStandChanged("Durchforstung", this);
    } else {

        for (int i = 0; i < nSimSteps; i++) {
//        System.out.println("St.status+ harvesttype:"+st.status+"  "+st.trule.typeOfHarvest+" "+st.trule.lastTreatment);
            st.descspecies();
            System.out.println("Bestandestyp. st.temp_Integer "+st.temp_Integer);
// Behandlungskette wechseln
//            if (st.bt > 0 && st.wet < 0 && st.wet != st.bt){
//                st.wet = st.bt;
//                stpanel.setStand(st);
//            }
            
            
//        treat.executeManager2(st);
//        stpanel.chainExecute(st);
            teChain = stpanel.getChain();
            teChain.execute(st);
            st.descspecies();
            st.executeMortality();
            st.descspecies();
            if (autosave){
                TreegrossXML2 treegrossXML2 = new TreegrossXML2();
                if (currentFile.indexOf(".")< 12 ) currentFile=currentFile+System.getProperty("file.separator")+"temp.xml";
                Integer jj = st.year; 
                String fname = currentFile.substring(0, currentFile.length()-4)+"_"+jj.toString()+".xml";
//                st.modelRegion = fname.replace(".xml",".jpg");
                treegrossXML2.saveAsXML(st,fname);
            }
            
            
            
            int time = st.timeStep;
            if (simTime < st.timeStep) {
                time = simTime;
            }
            yt.enterStandDesc(st);
            st.grow(time, st.ingrowthActive);
            simTime = simTime - st.timeStep;
            st.bt = wetlist.findWet(st);
            jLabel3.setText(new Integer(st.bt).toString());

        }
    }

    
}//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        String fileName = st.programDir + System.getProperty("file.separator") + "help" + System.getProperty("file.separator") + "FSSilviculture.pdf";
        String seite = "file:" + System.getProperty("file.separator") + System.getProperty("file.separator") + System.getProperty("file.separator") + fileName;
        StartBrowser startBrowser = new StartBrowser(seite);
        startBrowser.start();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        // TODO add your handling code here:
        System.out.println("Textfeld gendert");
        int btx =-999;
        st.temp_Integer = 0;
        try {       
            btx = Integer.parseInt(jTextField1.getText());
        } catch (Exception e) { };
        st.wet = btx;
        if (st.bt < -998) st.bt=btx;
        st.trule.standType=-999;
        stpanel.setStand(st);
    }//GEN-LAST:event_jTextField1ActionPerformed
   

    public void setStand(Stand st) {
        int wetalt = 0;
        try {
            wetalt = Integer.parseInt(jTextField1.getText());
        } catch (Exception e) {
            st.wet = 0;
        }
        st.bt = wetlist.findWet(st);
        if (st.wet <= 0) {
            st.wet = st.bt;
            stpanel.setStand(st);
            jTextField1.setText(new Integer(st.wet).toString());
        }
        jLabel3.setText(new Integer(st.bt).toString());

    }
    
    public void executeTreatment(Stand st) {
        if (jCheckBox1.isSelected()) {
            st.random.setRandomType(11);
        } else {
            st.random.setRandomType(10);
        }
        st.ingrowthActive = jCheckBox2.isSelected();
        st.riskActive = jCheckBox5.isSelected();
        st.distanceDependent = true;
        st.descspecies();
        teChain = stpanel.getChain();
        teChain.execute(st);
        st.descspecies();
        st.notifyStandChanged("Durchforstung", this);
    }
    


 
    

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField5;
    // End of variables declaration//GEN-END:variables
    
}
