/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package nwfva.biomass;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.text.NumberFormat;
import java.util.Locale;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import treegross.base.FunctionInterpreter;
import treegross.base.Tree;
import treegross.tools.XmlTool;

/**
 *
 * @author nagel
 */
public class Biomass {
    
    String xmlname ="";
    String localPath =""; 
    BiomassSetting2 bs[] = new BiomassSetting2[50];
    int nbs = 0;
    NumberFormat f;
    NumberFormat f4;

    
    public void calcAssortmentlist(String xmlname, String xmlout) {
        InputStream is = null;
        f = NumberFormat.getInstance(new Locale("en", "US"));
        f.setMaximumFractionDigits(2);
        f.setMinimumFractionDigits(2);
        f.setGroupingUsed(false);
        f4 = NumberFormat.getInstance(new Locale("en", "US"));
        f4.setMaximumFractionDigits(4);
        f4.setMinimumFractionDigits(4);
        f4.setGroupingUsed(false);

        try {
            this.xmlname = xmlname;
            File myFile = new File(xmlname);
            URL url = myFile.toURI().toURL();
            URLConnection urlcon = url.openConnection();
            is = urlcon.getInputStream();
            Element sortierung = null;
            try {

                Document d = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(is);
                sortierung = d.getDocumentElement();
            } catch (ParserConfigurationException | SAXException | IOException ex) {
                System.out.println("Fehler");
            }
// Ausgabe vorbereiten
            DocumentBuilderFactory docFactory2 = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder;
            try {

                docBuilder = docFactory2.newDocumentBuilder();
                Document doc = docBuilder.newDocument();
                doc.appendChild(doc.createProcessingInstruction("xml-stylesheet", "type=\"text/xsl\" href=\"nutrient.xsl\""));
//                doc.createComment("Testing");

                // add root element (stand)
                Element rootElt = doc.createElement("Biomass");
                doc.appendChild(rootElt);

                treegross.tools.XmlTool xmltool2 = new treegross.tools.XmlTool();

// Durcharbeiten der Parzellen und erstellen einer weiteren XML            
                NodeList sortimente = sortierung.getElementsByTagName("Sortiment");
                Node n3;
                FunctionInterpreter fi = new FunctionInterpreter();
                if (sortimente != null && sortimente.getLength() > 0) {
                    for (int ip = 0; ip < sortimente.getLength(); ip++) {
                        n3 = sortimente.item(ip);
                        String sortname = XmlTool.getChildText(n3, "Name");
                        String art = XmlTool.getChildText(n3, "Art");
                        String baumnr = XmlTool.getChildText(n3, "Baum_Nr");
                        String entnahme = XmlTool.getChildText(n3, "Entnahme");
                        String jahr = XmlTool.getChildText(n3, "Entnahmejahr");
                        String typ = XmlTool.getChildText(n3, "Entnahmetyp");
                        String faktor = XmlTool.getChildText(n3, "fac_ha");
                        double d = Double.parseDouble(XmlTool.getChildText(n3, "BHD"));
                        double h = Double.parseDouble(XmlTool.getChildText(n3, "Hoehe"));
                        double vmr = Double.parseDouble(XmlTool.getChildText(n3, "Vol_mR"));
                        double vor = Double.parseDouble(XmlTool.getChildText(n3, "Vol_oR"));
                        double vsmr = Double.parseDouble(XmlTool.getChildText(n3, "VsmR"));
                        double vsor = Double.parseDouble(XmlTool.getChildText(n3, "VsoR"));
// Index der Biomassefuntionen suchen
                        int artnr = Integer.parseInt(art);
                        int index = getbsIndex(artnr);
// pass variables by tree object                    
                        Tree atree = new Tree();
                        atree.d = d;
                        atree.h = h;
                        double v = fi.getValueForTree(atree, bs[index].stemVolumeFunction);
                        double fac = v/vsmr;
                        double vmrc = vmr * fac;
                        double vorc = vor * fac;
                        vsmr = vsmr *fac;
                        vsor = vsor *fac;
                        double woodbm = (vorc/vsor)* (fi.getValueForTree(atree, bs[index].stemBMkg) 
                              + fi.getValueForTree(atree, bs[index].stumpBMkg));
                        double barkbm = ((vmrc-vorc)/(vsmr-vsor)) * (fi.getValueForTree(atree, bs[index].barkBMkg)
                              + fi.getValueForTree(atree, bs[index].stumpBarkBMkg));
                        double woodC = woodbm * fi.getValueForTree(atree, bs[index].woodFacC);
                        double barkC = barkbm * fi.getValueForTree(atree, bs[index].barkFacC);
                        double woodN = woodbm * fi.getValueForTree(atree, bs[index].woodFacN);
                        double barkN = barkbm * fi.getValueForTree(atree, bs[index].barkFacN);
                        double woodS = woodbm * fi.getValueForTree(atree, bs[index].woodFacS);
                        double barkS = barkbm * fi.getValueForTree(atree, bs[index].barkFacS);
                        double woodP = woodbm * fi.getValueForTree(atree, bs[index].woodFacP);
                        double barkP = barkbm * fi.getValueForTree(atree, bs[index].barkFacP);
                        double woodK = woodbm * fi.getValueForTree(atree, bs[index].woodFacK);
                        double barkK = barkbm * fi.getValueForTree(atree, bs[index].barkFacK);
                        double woodCa = woodbm * fi.getValueForTree(atree, bs[index].woodFacCa);
                        double barkCa = barkbm * fi.getValueForTree(atree, bs[index].barkFacCa);
                        double woodMg = woodbm * fi.getValueForTree(atree, bs[index].woodFacMg);
                        double barkMg = barkbm * fi.getValueForTree(atree, bs[index].barkFacMg);
                        System.out.println(baumnr + " " + art);

                        Element elt = null;
                        elt = doc.createElement("Sortiment");
                        xmltool2.addChildString(elt, "Art", art);
                        xmltool2.addChildString(elt, "Baum_Nr", baumnr);
                        xmltool2.addChildString(elt, "Name", sortname);
                        xmltool2.addChildString(elt, "fac_ha", faktor);
                        xmltool2.addChildString(elt, "Entnahmejahr", jahr);
                        xmltool2.addChildString(elt, "Entnahme", entnahme);
                        xmltool2.addChildString(elt, "Entnahmetyp", typ);
                        xmltool2.addChildString(elt, "Typ", "Holz");
                        xmltool2.addChildString(elt, "BHD", f.format(d));
                        xmltool2.addChildString(elt, "Hoehe", f.format(h));
                        xmltool2.addChildString(elt, "Vol_mR", f4.format(vorc));
                        xmltool2.addChildString(elt, "Biomasse", f4.format(woodbm));
                        xmltool2.addChildString(elt, "C", f4.format(woodC/1000.0));
                        xmltool2.addChildString(elt, "N", f4.format(woodN));
                        xmltool2.addChildString(elt, "S", f4.format(woodS));
                        xmltool2.addChildString(elt, "P", f4.format(woodP));
                        xmltool2.addChildString(elt, "K", f4.format(woodK));
                        xmltool2.addChildString(elt, "Ca", f4.format(woodCa));
                        xmltool2.addChildString(elt, "Mg", f4.format(woodMg));
                        rootElt.appendChild(elt);
// Rinde
                        elt = doc.createElement("Sortiment");
                        xmltool2.addChildString(elt, "Art", art);
                        xmltool2.addChildString(elt, "Baum_Nr", baumnr);
                        xmltool2.addChildString(elt, "Name", sortname);
                        xmltool2.addChildString(elt, "fac_ha", faktor);
                        xmltool2.addChildString(elt, "Entnahmejahr", jahr);
                        xmltool2.addChildString(elt, "Entnahme", entnahme);
                        xmltool2.addChildString(elt, "Entnahmetyp", typ);
                        xmltool2.addChildString(elt, "Typ", "Rinde");
                        xmltool2.addChildString(elt, "BHD", f.format(d));
                        xmltool2.addChildString(elt, "Hoehe", f.format(h));
                        xmltool2.addChildString(elt, "Vol_mR", f4.format((vmrc-vorc)));
                        xmltool2.addChildString(elt, "Biomasse", f4.format(barkbm));
                        xmltool2.addChildString(elt, "C", f4.format(barkC/1000.0));
                        xmltool2.addChildString(elt, "N", f4.format(barkN));
                        xmltool2.addChildString(elt, "S", f4.format(barkS));
                        xmltool2.addChildString(elt, "P", f4.format(barkP));
                        xmltool2.addChildString(elt, "K", f4.format(barkK));
                        xmltool2.addChildString(elt, "Ca", f4.format(barkCa));
                        xmltool2.addChildString(elt, "Mg", f4.format(barkMg));

                        rootElt.appendChild(elt);
// wenn Restholz dann auch BLtter und Reisig                        
                        if (sortname.indexOf("Restholz") > -1) {
                            double branch = fi.getValueForTree(atree, bs[index].branchBMkg) ;
                            double reisig = fi.getValueForTree(atree, bs[index].reisigBMkg) ;
                            double reisigC = reisig * fi.getValueForTree(atree, bs[index].reisigFacC);
                            double reisigN = reisig * fi.getValueForTree(atree, bs[index].reisigFacN);
                            double reisigS = reisig * fi.getValueForTree(atree, bs[index].reisigFacS);
                            double reisigP = reisig * fi.getValueForTree(atree, bs[index].reisigFacP);
                            double reisigK = reisig * fi.getValueForTree(atree, bs[index].reisigFacK);
                            double reisigCa = reisig * fi.getValueForTree(atree, bs[index].reisigFacCa);
                            double reisigMg = reisig * fi.getValueForTree(atree, bs[index].reisigFacMg);
                            double branchC = branch * fi.getValueForTree(atree, bs[index].branchFacC);
                            double branchN = branch * fi.getValueForTree(atree, bs[index].branchFacN);
                            double branchS = branch * fi.getValueForTree(atree, bs[index].branchFacS);
                            double branchP = branch * fi.getValueForTree(atree, bs[index].branchFacP);
                            double branchK = branch * fi.getValueForTree(atree, bs[index].branchFacK);
                            double branchCa = branch * fi.getValueForTree(atree, bs[index].branchFacCa);
                            double branchMg = branch * fi.getValueForTree(atree, bs[index].branchFacMg);
                            
                            elt = doc.createElement("Sortiment");
                            xmltool2.addChildString(elt, "Art", art);
                            xmltool2.addChildString(elt, "Baum_Nr", baumnr);
                            xmltool2.addChildString(elt, "Name", "Reisig");
                            xmltool2.addChildString(elt, "fac_ha", faktor);
                            xmltool2.addChildString(elt, "Entnahmejahr", jahr);
                            xmltool2.addChildString(elt, "Entnahme", entnahme);
                            xmltool2.addChildString(elt, "Entnahmetyp", typ);
                            xmltool2.addChildString(elt, "Typ", "Reisig");
                            xmltool2.addChildString(elt, "BHD", f.format(d));
                            xmltool2.addChildString(elt, "Hoehe", f.format(h));
                            xmltool2.addChildString(elt, "Vol_mR", "0.0");
                            xmltool2.addChildString(elt, "Biomasse", f4.format(reisig+branch));
                            xmltool2.addChildString(elt, "C", f4.format((reisigC+branchC)/1000.0));
                            xmltool2.addChildString(elt, "N", f4.format(reisigN+branchN));
                            xmltool2.addChildString(elt, "S", f4.format(reisigS+branchS));
                            xmltool2.addChildString(elt, "P", f4.format(reisigP+branchP));
                            xmltool2.addChildString(elt, "K", f4.format(reisigK+branchK));
                            xmltool2.addChildString(elt, "Ca", f4.format(reisigCa+branchCa));
                            xmltool2.addChildString(elt, "Mg", f4.format(reisigMg+branchMg));
                            rootElt.appendChild(elt);

                            double blaetter = fi.getValueForTree(atree, bs[index].leafBMkg);
                            double blaetterC = blaetter * fi.getValueForTree(atree, bs[index].leafFacC);
                            double blaetterN = blaetter * fi.getValueForTree(atree, bs[index].leafFacN);
                            double blaetterS = blaetter * fi.getValueForTree(atree, bs[index].leafFacS);
                            double blaetterP = blaetter * fi.getValueForTree(atree, bs[index].leafFacP);
                            double blaetterK = blaetter * fi.getValueForTree(atree, bs[index].leafFacK);
                            double blaetterCa = blaetter * fi.getValueForTree(atree, bs[index].leafFacCa);
                            double blaetterMg = blaetter * fi.getValueForTree(atree, bs[index].leafFacMg);
                            elt = doc.createElement("Sortiment");
                            xmltool2.addChildString(elt, "Art", art);
                            xmltool2.addChildString(elt, "Baum_Nr", baumnr);
                            xmltool2.addChildString(elt, "Name", "Blaetter");
                            xmltool2.addChildString(elt, "fac_ha", faktor);
                            xmltool2.addChildString(elt, "Entnahmejahr", jahr);
                            xmltool2.addChildString(elt, "Entnahme", entnahme);
                            xmltool2.addChildString(elt, "Entnahmetyp", typ);
                            xmltool2.addChildString(elt, "Typ", "Blaetter");
                            xmltool2.addChildString(elt, "BHD", f.format(d));
                            xmltool2.addChildString(elt, "Hoehe", f.format(h));
                            xmltool2.addChildString(elt, "Vol_mR", "0.0");
                            xmltool2.addChildString(elt, "Biomasse", f4.format(blaetter));
                            xmltool2.addChildString(elt, "C", f4.format(blaetterC/1000));
                            xmltool2.addChildString(elt, "N", f4.format(blaetterN));
                            xmltool2.addChildString(elt, "S", f4.format(blaetterS));
                            xmltool2.addChildString(elt, "P", f4.format(blaetterP));
                            xmltool2.addChildString(elt, "K", f4.format(blaetterK));
                            xmltool2.addChildString(elt, "Ca", f4.format(blaetterCa));
                            xmltool2.addChildString(elt, "Mg", f4.format(blaetterMg));

                            rootElt.appendChild(elt);

                        }

                    }
                }


                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                DOMSource source = new DOMSource(doc);

                StreamResult result = new StreamResult(new File(xmlout));
                transformer.transform(source, result);

            } catch (Exception ex) {
                System.out.println("Fehler");
            }

        } catch (IOException e) {
            System.out.println("Fehler");
        } finally {
            if (is != null) {
                try {
                    is.close();
                } catch (IOException ex) {
                    System.out.println("Fehler");
                }
            }
        }

    }
    
    
    public void loadnbs(String biomassXML) {
        nbs = 0;
        try {
            File myFile = new File(biomassXML);
            URL url = myFile.toURI().toURL();
            URLConnection urlcon = url.openConnection();
            Document d = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(urlcon.getInputStream());
            Element Species = d.getDocumentElement();
            NodeList species = Species.getElementsByTagName("Species");
            Node spec;
            for (int ikas = 0; ikas < species.getLength(); ikas++) {
                spec = species.item(ikas);
//
                bs[nbs] = new BiomassSetting2();
                bs[nbs].code = Integer.parseInt(XmlTool.getChildText(spec,"Code"));
                bs[nbs].specieslist = XmlTool.getChildText(spec,"Specieslist");
                bs[nbs].stumpBMkg = XmlTool.getChildText(spec,"StumpBMkg");
                bs[nbs].stumpBarkBMkg = XmlTool.getChildText(spec,"StumpBarkBMkg");
                bs[nbs].leafBMkg = XmlTool.getChildText(spec,"LeafBMkg");
                bs[nbs].stemBMkg = XmlTool.getChildText(spec,"StemBMkg");
                bs[nbs].barkBMkg = XmlTool.getChildText(spec,"BarkBMkg");
                bs[nbs].branchBMkg = XmlTool.getChildText(spec,"BranchBMkg");
                try {
                   bs[nbs].reisigBMkg = XmlTool.getChildText(spec,"ReisigBMkg");
                   if (bs[nbs].reisigBMkg == null)  bs[nbs].reisigBMkg = "0.0";
                } catch (Exception e) {
                   bs[nbs].reisigBMkg = "0.0"; 
                }
                bs[nbs].woodFacC = XmlTool.getChildText(spec,"WoodFacC");
                bs[nbs].woodFacN =XmlTool.getChildText(spec,"WoodFacN");
                bs[nbs].woodFacS =XmlTool.getChildText(spec,"WoodFacS");
                bs[nbs].woodFacP =XmlTool.getChildText(spec,"WoodFacP");
                bs[nbs].woodFacK =XmlTool.getChildText(spec,"WoodFacK");
                bs[nbs].woodFacCa =XmlTool.getChildText(spec,"WoodFacCa");
                bs[nbs].woodFacMg =XmlTool.getChildText(spec,"WoodFacMg");
                bs[nbs].woodFacMn =XmlTool.getChildText(spec,"WoodFacMn");
                bs[nbs].woodFacFe =XmlTool.getChildText(spec,"WoodFacFe");
                bs[nbs].woodFacBOup =XmlTool.getChildText(spec,"WoodFacBOup");
                bs[nbs].woodFacBNH4 =XmlTool.getChildText(spec,"WoodFacBNH4");
                bs[nbs].woodFacBNO3 =XmlTool.getChildText(spec,"WoodFacBNO3");
                bs[nbs].barkFacC =XmlTool.getChildText(spec,"BarkFacC");
                bs[nbs].barkFacN =XmlTool.getChildText(spec,"BarkFacN");
                bs[nbs].barkFacS =XmlTool.getChildText(spec,"BarkFacS");
                bs[nbs].barkFacP =XmlTool.getChildText(spec,"BarkFacP");
                bs[nbs].barkFacK =XmlTool.getChildText(spec,"BarkFacK");
                bs[nbs].barkFacCa =XmlTool.getChildText(spec,"BarkFacCa");
                bs[nbs].barkFacMg =XmlTool.getChildText(spec,"BarkFacMg");
                bs[nbs].barkFacMn =XmlTool.getChildText(spec,"BarkFacMn");
                bs[nbs].barkFacFe =XmlTool.getChildText(spec,"BarkFacFe");
                bs[nbs].barkFacBOup =XmlTool.getChildText(spec,"BarkFacBOup");
                bs[nbs].barkFacBNH4 =XmlTool.getChildText(spec,"BarkFacBNH4");
                bs[nbs].barkFacBNO3 =XmlTool.getChildText(spec,"BarkFacBNO3");
                bs[nbs].branchFacC =XmlTool.getChildText(spec,"BranchFacC");
                bs[nbs].branchFacN =XmlTool.getChildText(spec,"BranchFacN");
                bs[nbs].branchFacS =XmlTool.getChildText(spec,"BranchFacS");
                bs[nbs].branchFacP =XmlTool.getChildText(spec,"BranchFacP");
                bs[nbs].branchFacK =XmlTool.getChildText(spec,"BranchFacK");
                bs[nbs].branchFacCa =XmlTool.getChildText(spec,"BranchFacCa");
                bs[nbs].branchFacMg =XmlTool.getChildText(spec,"BranchFacMg");
                bs[nbs].branchFacMn =XmlTool.getChildText(spec,"BranchFacMn");
                bs[nbs].branchFacFe =XmlTool.getChildText(spec,"BranchFacFe");
                bs[nbs].branchFacBOup =XmlTool.getChildText(spec,"BranchFacBOup");
                bs[nbs].branchFacBNH4 =XmlTool.getChildText(spec,"BranchFacBNH4");
                bs[nbs].branchFacBNO3 =XmlTool.getChildText(spec,"BranchFacBNO3");
                try {
                    bs[nbs].reisigFacC =XmlTool.getChildText(spec,"ReisigFacC");
                    if (bs[nbs].reisigFacC == null) bs[nbs].reisigFacC ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacC = "0.0";
                }
                try {
                    bs[nbs].reisigFacN =XmlTool.getChildText(spec,"ReisigFacN");
                    if (bs[nbs].reisigFacN == null) bs[nbs].reisigFacN ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacN = "0.0";
                }
                try {
                    bs[nbs].reisigFacS =XmlTool.getChildText(spec,"ReisigFacS");
                    if (bs[nbs].reisigFacS == null) bs[nbs].reisigFacS ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacS = "0.0";
                }
                try {
                    bs[nbs].reisigFacP =XmlTool.getChildText(spec,"ReisigFacP");
                    if (bs[nbs].reisigFacP == null) bs[nbs].reisigFacP ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacP = "0.0";
                }
                try {
                    bs[nbs].reisigFacK =XmlTool.getChildText(spec,"ReisigFacK");
                    if (bs[nbs].reisigFacK == null) bs[nbs].reisigFacK ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacK = "0.0";
                }
                try {
                    bs[nbs].reisigFacCa =XmlTool.getChildText(spec,"ReisigFacCa");
                    if (bs[nbs].reisigFacCa == null) bs[nbs].reisigFacCa ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacCa = "0.0";
                }
                try {
                    bs[nbs].reisigFacMg =XmlTool.getChildText(spec,"ReisigFacMg");
                    if (bs[nbs].reisigFacMg == null) bs[nbs].reisigFacMg ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacMg = "0.0";
                }
                try {
                    bs[nbs].reisigFacMn =XmlTool.getChildText(spec,"ReisigFacMn");
                    if (bs[nbs].reisigFacMn == null) bs[nbs].reisigFacMn ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacMn = "0.0";
                }
                try {
                    bs[nbs].reisigFacFe =XmlTool.getChildText(spec,"ReisigFacFe");
                    if (bs[nbs].reisigFacFe == null) bs[nbs].reisigFacFe ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacFe = "0.0";
                }
                try {
                    bs[nbs].reisigFacBOup =XmlTool.getChildText(spec,"ReisigFacBOup");
                    if (bs[nbs].reisigFacBOup == null) bs[nbs].reisigFacBOup ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacBOup = "0.0";
                }
                try {
                    bs[nbs].reisigFacBNH4 =XmlTool.getChildText(spec,"ReisigFacBNH4");
                    if (bs[nbs].reisigFacBNH4 == null) bs[nbs].reisigFacBNH4 ="0.0";

                } catch (Exception e) {
                    bs[nbs].reisigFacBNH4 = "0.0";
                }
                try {
                    bs[nbs].reisigFacBNO3 =XmlTool.getChildText(spec,"ReisigFacBNO3");
                    if (bs[nbs].reisigFacBNO3 == null) bs[nbs].reisigFacBNO3 ="0.0";
                } catch (Exception e) {
                    bs[nbs].reisigFacBNO3 = "0.0";
                }

                bs[nbs].leafFacC =XmlTool.getChildText(spec,"LeafFacC");
                bs[nbs].leafFacN =XmlTool.getChildText(spec,"LeafFacN");
                bs[nbs].leafFacS =XmlTool.getChildText(spec,"LeafFacS");
                bs[nbs].leafFacP =XmlTool.getChildText(spec,"LeafFacP");
                bs[nbs].leafFacK =XmlTool.getChildText(spec,"LeafFacK");
                bs[nbs].leafFacCa =XmlTool.getChildText(spec,"LeafFacCa");
                bs[nbs].leafFacMg =XmlTool.getChildText(spec,"LeafFacMg");
                bs[nbs].leafFacMn =XmlTool.getChildText(spec,"LeafFacMn");
                bs[nbs].leafFacFe =XmlTool.getChildText(spec,"LeafFacFe");
                bs[nbs].leafFacBOup =XmlTool.getChildText(spec,"LeafFacBOup");
                bs[nbs].leafFacBNH4 =XmlTool.getChildText(spec,"LeafFacBNH4");
                bs[nbs].leafFacBNO3 =XmlTool.getChildText(spec,"LeafFacBNO3");
                bs[nbs].woodDensity =XmlTool.getChildText(spec,"WoodDensity");
                bs[nbs].stemVolumeFunction =XmlTool.getChildText(spec,"StemVolume");
                bs[nbs].taperFuctionClass =XmlTool.getChildText(spec,"TaperClass");
                bs[nbs].taperFunctionNumber = Integer.parseInt(XmlTool.getChildText(spec,"TaperFunctionNumber"));
                nbs = nbs + 1;
            }

        } catch (Exception e) {
            System.out.println("Fehler: Keine Biomassenfunktionen geladen");
        }

    }
    
    private int getbsIndex(int code) {
        int index = -9;
        for (int i = 0; i < nbs; i++) {
            if (code == bs[i].code) {
                index = i;
            }
        }
        if (index < 0) {
            for (int i = 0; i < nbs; i++) {
                String co = Integer.toString(code);
                if (bs[i].specieslist.indexOf(co) > -1) {
                    index = i;
                }
            }
        }
        if (index < 0) {
            String co = Integer.toString(code);
            co = co.substring(0,1) + "11";
            int cod = Integer.parseInt(co);
            for (int i = 0; i < nbs; i++) {
                if (cod == bs[i].code) {
                    index = i;
                }
            }
        }
        return index;
    }
  
}
