/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package nwfva.carboncalc;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import nwfva.assortment.LoggingSortiment;
import nwfva.assortment.TreeLog;
import nwfva.assortment.TreeSplitter;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import treegross.base.FunctionInterpreter;
import treegross.base.Stand;
import treegross.base.Tree;
import treegross.base.TreegrossXML2;
import treegross.tools.XmlTool;

/**
 *
 * @author nagel
 */
public class CarbonCalc {
    Stand st = null;
    LoggingSortiment lsort[] = null;
    Cascadefactor cf[] = null;
    List<CarbonResult> crl = new ArrayList<CarbonResult>();
    File sfl[] = null;
    BiomassSetting bs[] = new BiomassSetting[50];
    int nbs = 0;
    String carbonrsxml ="";

    public void CarbonCalc(){
        
    }
    public void calculate(Stand st, LoggingSortiment[] ls, File[] selectedF, String biomassxml,
        String cascadexml, String carbonresultXML){
        carbonrsxml = carbonresultXML;
        loadnbs(biomassxml);
        cf=loadcf(cascadexml);
        lsort=ls;
        this.st=st;
        
        
        
        
        for (int i = 0; i < lsort.length; i++) {
            System.out.println(lsort[i].name);
        }
        double pc[] = new double[5];
        double pcsum[] = new double[8];
//
        this.sfl = selectedF;
        for (int i = 0; i < sfl.length; i++) {
            System.out.println(sfl[i].getName());
        }
//
        FunctionInterpreter fi = new FunctionInterpreter();
        TreegrossXML2 treegrossXML2 = new TreegrossXML2();
        for (int ifile = 0; ifile < sfl.length; ifile++) {
            URL url = null;
            String fname = sfl[ifile].toString();
            int m = fname.toUpperCase().indexOf("FILE");
            int m2 = fname.toUpperCase().indexOf("HTTP");
            if (m < 0 && m2 < 0) {
                fname = "file:" + System.getProperty("file.separator")
                        + System.getProperty("file.separator") + System.getProperty("file.separator") + fname;
            }
            try {
                url = new URL(fname);
                st = treegrossXML2.readTreegrossStand(st, url);
                st.descspecies();
            } catch (Exception e2) {;
            }
// Berechnen und Zerlegen der Bume
            TreeLog tl[] = new TreeLog[200];
            int ntl = 0;
// set felling height usually 0.3m
            double fellingHeight = 0.0;
// Sortierung
            TreeSplitter splitter = new TreeSplitter();
            splitter.setAssortments(lsort, lsort.length);
// Definition der Speicher
            double spBelow = 0.0;
            double spGround = 0.0;
            double spAbove = 0.0;
            double spc1 = 0.0;
            double spc2 = 0.0;
            double spc3 = 0.0;
            double spc4 = 0.0;
            double subst = 0.0;
            for (int i = 0; i < 8; i++) {
                pcsum[i] = 0.0;
            }

            for (int i = 0; i < st.ntrees; i++) {
                if (st.tr[i].d >= 7.0 && st.tr[i].h > 6.0 && st.tr[i].code != 999.0) {
// alle Bume durchlaufen
                    System.out.println("Splitter " + i + "  " + st.tr[i].no);
                    splitter.splitTree(st.tr[i], fellingHeight);
                    tl = splitter.getTreeLogs();
                    ntl = splitter.getNumberOfLogs();

                    int index = getbsIndex(st.tr[i].code);
                    Tree atree = new Tree();
                    atree.d = st.tr[i].d;
                    atree.h = st.tr[i].h;
                    double v = fi.getValueForTree(atree, bs[index].stemVolumeFunction);
                    double woodbm = fi.getValueForTree(atree, bs[index].stemBMkg)
                            + fi.getValueForTree(atree, bs[index].stumpBMkg);
                    double barkbm = fi.getValueForTree(atree, bs[index].barkBMkg)
                            + fi.getValueForTree(atree, bs[index].stumpBarkBMkg);
                    double woodC = woodbm * fi.getValueForTree(atree, bs[index].woodFacC) / 1000.0;
                    double barkC = barkbm * fi.getValueForTree(atree, bs[index].barkFacC) / 1000.0;
                    double volbark = 0.0;
                    double voloR = 0.0;
                    for (int k = 0; k < ntl; k++) {
                        voloR = voloR + tl[k].vol_oR;
                        volbark = volbark + tl[k].vol_mR - tl[k].vol_oR;
                    }
                    double branch = fi.getValueForTree(atree, bs[index].branchBMkg);
                    double reisig = fi.getValueForTree(atree, bs[index].reisigBMkg);
                    double reisigC = reisig * fi.getValueForTree(atree, bs[index].reisigFacC) / 1000.0;
                    double branchC = branch * fi.getValueForTree(atree, bs[index].branchFacC) / 1000.0;
                    double rootC = 0.5 * fi.getValueForTree(atree, bs[index].rootBM) ;
// Die unterirdische Biomasse
                    pcsum[0] = pcsum[0] + rootC;
// Baum lebt
                    if (st.tr[i].out < 0) {
                        pcsum[2] = pcsum[2] + woodC + barkC + reisigC + branchC;
                    }
// Baum abgestorben                
                    if (st.tr[i].out > 0 && st.tr[i].outtype < 2) {
                        pcsum[1] = pcsum[1] + woodC + barkC + reisigC + branchC;
                    }
// Baum genutzt
                    if (st.tr[i].out > 0 && st.tr[i].outtype > 1) {
                        
// alle ausgewhlten Sortimente bearbeiten                 
                        for (int jj = 0; jj < ntl; jj++) {
//                         System.out.println("Baum: " + st.tr[i].no + " h: " + tl[jj].startHeight);
                            if (!tl[jj].removed) {
                                if (tl[jj].sortName.equals("Kronenholz***")) {
                                    pcsum[1] = pcsum[1] + reisigC + branchC;
                                } else {
                                    pcsum[1] = pcsum[1] + (tl[jj].vol_oR / voloR) * woodC;
                                    pcsum[1] = pcsum[1] + ((tl[jj].vol_mR - tl[jj].vol_oR) / volbark) * barkC;
                                }
                            } else {
// Hier muss die Produktklassenberechnun rein mit der Substitution
//
                                double carb = 0.0;
                                if (tl[jj].sortName.equals("Kronenholz***")) {
                                    carb = reisigC + branchC;
                                } else {

                                    carb = (tl[jj].vol_oR / voloR) * woodC + ((tl[jj].vol_mR - tl[jj].vol_oR) / volbark) * barkC;
                                }
                                Cascadefactor cfi = new Cascadefactor();
                                cfi = cf[getCFIndex(st.tr[i].code)];
                                int jahrent = Math.abs(st.tr[i].out);
                                pc = calcCascade(tl[jj].productclass, jahrent, st.year, carb, cfi);
                                for (int ikk = 0; ikk < 5; ikk++) {
                                    pcsum[ikk + 3] = pcsum[ikk + 3] + pc[ikk];
                                }

                            }

                        }
                    }
                }
            }
            for (int ikk = 0; ikk < 8; ikk++) {
                pcsum[ikk] = pcsum[ikk] / (1000.0 * st.size);
            }

            crl.add(new CarbonResult(st.standname, st.year, pcsum));

        }
// Ende der Schleife fr die Datenfiles  ifile   

        writeCarbonXML(crl);
        Cascadefactor cfi = cf[getCFIndex(211)];
    
        pc = calcCascade(4, 2000, 2060, 200, cfi);
        for (int i=0;i<5;i++) System.out.println(" Ausgabe: "+ pc[i]);
        

    }
    
    private void writeCarbonXML(List <CarbonResult> crl){
        InputStream is = null;
        NumberFormat f;
        NumberFormat f4;
        f = NumberFormat.getInstance(new Locale("en", "US"));
        f.setMaximumFractionDigits(2);
        f.setMinimumFractionDigits(2);
        f.setGroupingUsed(false);
        f4 = NumberFormat.getInstance(new Locale("en", "US"));
        f4.setMaximumFractionDigits(4);
        f4.setMinimumFractionDigits(4);
        f4.setGroupingUsed(false);
        try {

// Ausgabe vorbereiten
            DocumentBuilderFactory docFactory2 = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder;

            docBuilder = docFactory2.newDocumentBuilder();
            org.w3c.dom.Document doc = docBuilder.newDocument();
            doc.appendChild(doc.createProcessingInstruction("xml-stylesheet", "type=\"text/xsl\" href=\"carbonresult.xsl\""));

            // add root element (stand)
            org.w3c.dom.Element rootElt = doc.createElement("Carbon");
            doc.appendChild(rootElt);

            treegross.tools.XmlTool xmltool2 = new treegross.tools.XmlTool();

// Durcharbeiten der Parzellen und erstellen einer weiteren XML            
            for (int ip = 0; ip < lsort.length; ip++) {
                org.w3c.dom.Element elt = null;
                elt = doc.createElement("Sortiment");
                xmltool2.addChildString(elt, "name", lsort[ip].name);
                xmltool2.addChildString(elt, "von_Art", new Integer(lsort[ip].artvon).toString());
                xmltool2.addChildString(elt, "bis_Art", new Integer(lsort[ip].artbis).toString());
                xmltool2.addChildString(elt, "entnahme", new Boolean(lsort[ip].entnahme).toString());
                xmltool2.addChildString(elt, "zopf", new Double(lsort[ip].minTop).toString());
                xmltool2.addChildString(elt, "dmin", new Double(lsort[ip].minD).toString());
                xmltool2.addChildString(elt, "produktklasse", new Integer(lsort[ip].productclass).toString());
                rootElt.appendChild(elt);
            }
            CarbonResult cr = null;
            for (int ip = 0; ip < crl.size(); ip++) {
                cr = crl.get(ip);
                org.w3c.dom.Element elt = null;
                elt = doc.createElement("CarbonResult");
                xmltool2.addChildString(elt, "name", cr.name);
                xmltool2.addChildString(elt, "jahr", new Integer(cr.year).toString());
                xmltool2.addChildString(elt, "Wurzel_tha", f.format(cr.wert[0]));
                xmltool2.addChildString(elt, "Grund_tha", f.format(cr.wert[1]));
                xmltool2.addChildString(elt, "stehend_tha", f.format(cr.wert[2]));
                xmltool2.addChildString(elt, "Substitution_tha", f.format(cr.wert[3]));
                xmltool2.addChildString(elt, "Produktkl_1_tha", f.format(cr.wert[4]));
                xmltool2.addChildString(elt, "Produktkl_2_tha", f.format(cr.wert[5]));
                xmltool2.addChildString(elt, "Produktkl_3_tha", f.format(cr.wert[6]));
                xmltool2.addChildString(elt, "Produktkl_4_tha", f.format(cr.wert[7]));
                rootElt.appendChild(elt);
            }
            
            
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            DOMSource source = new DOMSource(doc);

            StreamResult result = new StreamResult(new File(carbonrsxml));
            transformer.transform(source, result);

        } catch (Exception e) {
            System.out.println("Fehler");
        } finally {
            if (is != null) {
                try {
                    is.close();
                } catch (IOException ex) {
                    System.out.println("Fehler");
                }
            }
        }
    }
    
    private int getCFIndex(int code){
        int index = 0;
        for (int i = 0; i < cf.length; i++) {
            if (code >= cf[i].artvon && code < cf[i].artbis) {
                index = i;
            }
        }
        return index;
    }
    
    private String fileStringToUrl(String fname){
        int m = fname.toUpperCase().indexOf("FILE");
        int m2 = fname.toUpperCase().indexOf("HTTP");
        if (m < 0 && m2 < 0) {
            fname = "file:" + System.getProperty("file.separator")
                    + System.getProperty("file.separator") + System.getProperty("file.separator") + fname;
        }
        return fname;
    }
    
    private Cascadefactor[] loadcf(String cascadeXML) {
        String fname = fileStringToUrl(cascadeXML);
        Cascadefactor cfs[] = null;
        try {
            URL url = new URL(fname);
            URLConnection urlcon = url.openConnection();
            Document d = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(urlcon.getInputStream());
            Element Kaskaden = d.getDocumentElement();
            NodeList kaskaden = Kaskaden.getElementsByTagName("Kaskade");
            Node kaskade;
            cfs = new Cascadefactor[kaskaden.getLength()];
            for (int ikas = 0; ikas < kaskaden.getLength(); ikas++) {
                kaskade = kaskaden.item(ikas);
                int pclass = 0;
                cfs[ikas] = new Cascadefactor();
                cfs[ikas].name = XmlTool.getChildText(kaskade, "Name");
                cfs[ikas].artvon = Integer.parseInt(XmlTool.getChildText(kaskade, "Art_von"));
                cfs[ikas].artbis = Integer.parseInt(XmlTool.getChildText(kaskade, "Art_bis"));
                String sbs = XmlTool.getChildText(kaskade, "Substitution");
                String[] sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].substitution[ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "Abbaurate");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].abbaurate[ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "CFaktor_P1");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].kaskade[0][ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "CFaktor_P2");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].kaskade[1][ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "CFaktor_P3");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].kaskade[2][ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "CFaktor_P4");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].kaskade[3][ik] = Double.parseDouble(sb[ik]);
                }
//            
                sbs = XmlTool.getChildText(kaskade, "Verteilung_P1");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].verteilung[0][ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "Verteilung_P2");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].verteilung[1][ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "Verteilung_P3");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].verteilung[2][ik] = Double.parseDouble(sb[ik]);
                }
                sbs = XmlTool.getChildText(kaskade, "Verteilung_P4");
                sb = sbs.split(";");
                for (int ik = 0; ik < sb.length; ik++) {
                    cfs[ikas].verteilung[3][ik] = Double.parseDouble(sb[ik]);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return cfs;
    }
    
     
    public double[] calcCascade(int pclass, int jahrentnahme, int jahrheute, double carbon, Cascadefactor cf) {
        double pc[] = new double[5];
        int npo = 0;
        ProductObject po[] = new ProductObject[800000];
        for (int i = 0; i < 4; i++) {
            if (cf.verteilung[pclass - 1][i] > 0.0) {
                po[npo] = new ProductObject(i + 1, jahrentnahme, carbon*(cf.verteilung[pclass - 1][i]/100.0), cf);
                npo = npo + 1;
            }
        }
        int nipo = (int) Math.floor((jahrheute - jahrentnahme) / 5);
        for (int ipo = 0; ipo < nipo; ipo++) {
            int yy = jahrentnahme + ((ipo + 1) * 5);
//            System.out.println("Testing  " + yy + " " + npo);
            int poneu = 0;
            for (int ip = 0; ip < npo; ip++) {
                if (po[ip].crest > 0) {
                    double w = po[ip].abbau(yy);
                    int npc = po[ip].pclass;
//                    System.out.println("Testing : " + yy + " " + w + "  " + po[ip].crest);
                    if (w > 1.0 && npc>1) {
                        for (int jjk = 0; jjk < 4; jjk++) {
                            if (cf.kaskade[npc-1][jjk] > 0.0) {
                                po[npo + poneu] = new ProductObject(jjk + 1, yy, w * (cf.kaskade[npc-1][jjk] / 100.0), cf);
                                poneu = poneu + 1;
                            }
                        }
                    }
                }
            }
            npo = npo + poneu;
        }
//        System.out.println("Testing  " + " " + npo);
        double sub = 0.0;
        double p4 = 0.0;
        double p3 = 0.0;
        double p2 = 0.0;
        double p1 = 0.0;
        for (int ip = 0; ip < npo; ip++) {
            sub = sub + po[ip].substitution;
            if (po[ip].pclass == 4) {
                p4 = p4 + po[ip].crest;
            }
            if (po[ip].pclass == 3) {
                p3 = p3 + po[ip].crest;
            }
            if (po[ip].pclass == 2) {
                p2 = p2 + po[ip].crest;
            }
            if (po[ip].pclass == 1) {
                p1 = p1 + po[ip].crest;
            }
        }
//        System.out.println("Testing Anzahl der Objekte " + " " + npo);
        
        pc[0] = sub;
        pc[1] = p1;
        pc[2] = p2;
        pc[3] = p3;
        pc[4] = p4;
        return pc;
    }
    
        public void loadnbs(String biomassXML) {
        nbs = 0;
        String fname = fileStringToUrl(biomassXML);
        try {
            URL url = new URL(fname);
            URLConnection urlcon = url.openConnection();
            Document d = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(urlcon.getInputStream());
            Element Species = d.getDocumentElement();
            NodeList speciesNL = Species.getElementsByTagName("Species");
            Node species;
            for (int ikas = 0; ikas < speciesNL.getLength(); ikas++) {
                species = speciesNL.item(ikas);
                bs[nbs] = new BiomassSetting();
                bs[nbs].code = Integer.parseInt(XmlTool.getChildText(species, "code"));
                bs[nbs].specieslist = XmlTool.getChildText(species, "SpeciesList");
                bs[nbs].stumpBMkg = XmlTool.getChildText(species, "StumpBMkg");
                bs[nbs].stumpBarkBMkg = XmlTool.getChildText(species, "StumpBarkBMkg");
                bs[nbs].leafBMkg = XmlTool.getChildText(species, "LeafBMkg");
                bs[nbs].stemBMkg = XmlTool.getChildText(species, "StemBMkg");
                bs[nbs].barkBMkg = XmlTool.getChildText(species, "BarkBMkg");
                bs[nbs].branchBMkg = XmlTool.getChildText(species, "BranchBMkg");
                try {
                   bs[nbs].reisigBMkg = XmlTool.getChildText(species, "ReisigBMkg");
                } catch (Exception e) {
                   bs[nbs].reisigBMkg = "0.0"; 
                }
                if (bs[nbs].reisigBMkg == null) bs[nbs].reisigBMkg = "0.0"; 
                bs[nbs].woodFacC = XmlTool.getChildText(species, "WoodFacC");
                bs[nbs].barkFacC = XmlTool.getChildText(species, "BarkFacC");
                bs[nbs].branchFacC = XmlTool.getChildText(species, "BranchFacC");
                try {
                    bs[nbs].reisigFacC = XmlTool.getChildText(species, "ReisigFacC");
                } catch (Exception e) {
                    bs[nbs].reisigFacC = "0.0";
                }
                if (bs[nbs].reisigFacC == null) bs[nbs].reisigFacC = "0.0"; 
                bs[nbs].leafFacC = XmlTool.getChildText(species, "LeafFacC");
                bs[nbs].woodDensity = XmlTool.getChildText(species, "WoodDensity");
                bs[nbs].stemVolumeFunction = XmlTool.getChildText(species, "StemVolume");
                bs[nbs].taperFuctionClass = XmlTool.getChildText(species, "TaperClass");
                bs[nbs].taperFunctionNumber = Integer.parseInt(XmlTool.getChildText(species, "TaperFunctionNumber"));
                try {
                   bs[nbs].rootBM = XmlTool.getChildText(species, "BiomassOfTotalRoots");
                } catch (Exception e) {
                   bs[nbs].rootBM = "0.0"; 
                }               
                if (bs[nbs].rootBM == null) bs[nbs].rootBM = "0.0"; 
                nbs = nbs + 1;
            }
            

        } catch (Exception e) {
            System.out.println("Fehler: Keine Biomassenfunktionen geladen");
        }

    }
    
    private int getbsIndex(int code) {
        int index = -9;
        for (int i = 0; i < nbs; i++) {
            if (code == bs[i].code) {
                index = i;
            }
        }
        if (index < 0) {
            for (int i = 0; i < nbs; i++) {
                String co = Integer.toString(code);
                if (bs[i].specieslist.indexOf(co) > -1) {
                    index = i;
                }
            }
        }
        if (index < 0) {
            String co = Integer.toString(code);
            co = co.substring(0,1) + "11";
            int cod = Integer.parseInt(co);
            for (int i = 0; i < nbs; i++) {
                if (cod == bs[i].code) {
                    index = i;
                }
            }
        }
        return index;
    }
    
    
}
