/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package treegross.singletreecompetition;

import java.util.Stack;
import org.nfunk.jep.ParseException;
import org.nfunk.jep.function.PostfixMathCommand;

/**
 *
 * @author sprauer
 */
public class InvLogit extends PostfixMathCommand {

    public InvLogit() {
        numberOfParameters = 1;
    }

    @Override
    public void run(Stack inStack) throws ParseException {
        // check the stack
        checkStack(inStack);

        // get the parameter from the stack
        Object param = inStack.pop();

        // check whether the argument is of the right type
        if (param instanceof Number) {
            // calculate the result
            double r = Math.exp((double) param) / (1 + Math.exp((double) param));
            // push the result on the inStack
            inStack.push(r);
        } else {
            throw new ParseException("Invalid parameter type");
        }
    }

}
